// 
// `֘Ȁt@C
// 

#include "stdinc.h"
#include "syscall.h"
#include "pg.h"
#include "pce.h"
#include "main.h"
#include "string.h"
#include "sound.h"
#include "hue_image.h"


// external
extern int skip_next_frame;
extern EmuConfig  eConf;
extern EmuRuntime eRun;

// global
int skip_next_vsync=0;

//
char img_dbg_string[20][128];
int  img_dbg_count[20]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

#define IMG_DBG_TIME 100

void imgSetString(char *str)
{
    int i,s=99999,idx=-1;
    
    for(i=0;i<20;i++) {
        if(img_dbg_count[i]==0) {
            idx = i;
            break;
        } else {
            if(s>img_dbg_count[i]) {
                s=img_dbg_count[i];
                idx=i;
            }
        }
    }

    if(idx!=-1) {
        img_dbg_count[idx] = IMG_DBG_TIME;
        _strcpy(img_dbg_string[idx],str);
    }
}

void imgPrtString(void)
{
    int i,sx=400,sy=10;
    
    for(i=0;i<20;i++) {
        if(img_dbg_count[i]>0) {
            mh_print(sx,sy,img_dbg_string[i],RGB_WHITE);
            img_dbg_count[i]--;
        }
        sy+=10;
    }
}

void imageDebugPrint(int x,int y,int w,int h)
{
    int fps;
    static DWORD lasttick=100;
    static int   framerate=0;

    if(eConf.debug) {
        register DWORD curtick = sceKernelLibcClock();
        if(curtick>lasttick) {
            framerate = (framerate + (curtick-lasttick))/2;
        }
        lasttick = curtick;
        if(framerate==0) fps = 0;
        else             fps = ((10000000/(framerate))+9)/10;
        
        mh_print_dec (0,0,fps,RGB_WHITE);
        mh_print_hex4( 0,10,x,RGB_WHITE);
        mh_print_hex4(30,10,y,RGB_WHITE);
        mh_print_hex4( 0,20,w,RGB_WHITE);
        mh_print_hex4(30,20,h,RGB_WHITE);
#ifdef SOUND
        dbgSound();
#endif // SOUND
#ifdef CDEMULATION
        dbgCDPlay();
#endif//CDEMULATION
        //imgPrtString();
    }

}


//---------------------------------------------------------------
// 
//---------------------------------------------------------------
void frame_skip(void)
{
    static int skipflip=0;
    // auto skip
    switch(eConf.skip) {
      case 0: break; // no skip
      case 5: break; // auto skip
      default: //4,3,2,1
        if(skipflip) {
            if(eRun.frame<eConf.skip) {
                skip_next_frame = 1;
                
                eRun.frame = (eRun.frame+1) % 4;
            }
        }

        skipflip=1-skipflip;
        break;
    }
}


#ifdef PALWORD //---------------------------------------------------------------

void dbgCDPlay(void);

// Video BufferEDRAMɊmۂ
PALFMT * xbuf[2] = {
    (PALFMT*)0x04100000,
    (PALFMT*)0x04180000
  };

// Cɗ̈mۂ
PALFMT xbuf_main[WIDTH*HEIGHT+8];


// initialize
void InitImage(void)
{
    if(!pgPSP()) {
        xbuf[0] = xbuf_main;
        xbuf[1] = xbuf_main;
    }
    
    ClearImage();
    XBuf = xbuf[0];
}

static int flipPage=0;

//
//
//
void PutImageGpu(int x,int y,int w,int h)
{
    static int qid = 0;

    if( qid ) {
        // Vsync wait
        if(eConf.vsync && !skip_next_vsync) {
            pgWaitV();
        }
        sceGeListSync(qid, 0);
        imageDebugPrint(x,y,w,h);
        // flip
        pgScreenFlip();
        qid = 0;
    }
    
    {
        unsigned int log2w, log2h;
        static unsigned int GEcmd[16];
        static short ScreenVertex[10] __attribute__((aligned(64))) =  {
            //0  1  2  3  4    5    6    7    8  9
              0, 0, 0, 0, 0, 256, 224, 480, 272, 0
            };

        //unsigned char * screen = (unsigned char*)&XBuf[x];
        unsigned short * screen = &XBuf[ x + y*WIDTH ];
               
        switch(eConf.video) {
          case 2: /* FIT4:3*/
            ScreenVertex[2] = (480-362)/2;
            ScreenVertex[3] = 0;
            ScreenVertex[5] = w;
            ScreenVertex[6] = h;
            ScreenVertex[7] = (480-362)/2 + 362;
            ScreenVertex[8] = 272;
            break;

          case 3: /* FULL SCREEN */
            ScreenVertex[2] = 0;
            ScreenVertex[3] = 0;
            ScreenVertex[5] = w;
            ScreenVertex[6] = h;
            ScreenVertex[7] = 480;
            ScreenVertex[8] = 272;
            break;
            
          case 1: /* NORMAL */
          default:
            ScreenVertex[2] = (480-w)/2;
            ScreenVertex[3] = (272-h)/2;
            ScreenVertex[5] = w;
            ScreenVertex[6] = h;
            ScreenVertex[7] = (480-w)/2 + w; // 480;
            ScreenVertex[8] = (272-h)/2 + h;
            break;
        }
        
		// Set Draw Buffer
		GEcmd[ 0] = 0x9C000000UL | ((u32)(unsigned char *)pgGetVramAddr( 0, 0 ) & 0x00FFFFFF);
		GEcmd[ 1] = 0x9D000000UL | (((u32)(unsigned char *)pgGetVramAddr( 0, 0 ) & 0xFF000000) >> 8) | 512;
		// Set Tex Buffer
		GEcmd[ 2] = 0xA0000000UL | ((u32)(unsigned char *)screen & 0x00FFFFFF);
		GEcmd[ 3] = 0xA8000000UL | (((u32)(unsigned char *)screen & 0xFF000000) >> 8) | 512;
		if (w > 256) log2w = 9;
		else log2w = 8;
		if (h > 256) log2h = 9;
		else log2h = 8;
		GEcmd[ 4] = 0xB8000000UL | (log2h << 8) | log2w;
		// Tex Flush
		GEcmd[ 5] = 0xCB000000UL;
		// Set Vertex
		GEcmd[ 6] = 0x12000000UL | (1 << 23) | (0 << 11) | (0 << 9) | (2 << 7) | (0 << 5) | (0 << 2) | 2;
		GEcmd[ 7] = 0x10000000UL;
		GEcmd[ 8] = 0x02000000UL;
		GEcmd[ 9] = 0x10000000UL | (((u32)(void *)&ScreenVertex & 0xFF000000) >> 8);
		GEcmd[10] = 0x01000000UL | ((u32)(void *)&ScreenVertex & 0x00FFFFFF);
		// Draw Vertex
		GEcmd[11] = 0x04000000UL | (6 << 16) | 2;
		// List End
		GEcmd[12] = 0x0F000000UL;
		GEcmd[13] = 0x0C000000UL;
		GEcmd[14] = 0;
		sceKernelDcacheWritebackAll();
		qid = sceGeListEnQueue(&GEcmd[0], &GEcmd[14], -1, NULL);
    }
    
    flipPage=1-flipPage;
    XBuf = xbuf[flipPage];

}



//
// draw image
//
void PutImageNormal(int x,int y,int w,int h)
{
    register int sx = (SCREEN_WIDTH - w)/2;
    register int sy = (SCREEN_HEIGHT- h - y)/2;
    register int i,j;
    
    for(j=0;j<h;j++) {    // 16bit palette
        register DWORD* dst = (DWORD*)pgGetVramAddr(sx,sy+j);
        register DWORD* src = (DWORD*)&XBuf[WIDTH*(j+y)+x];
        for(i=0;i<w/2;i++) {
            dst[0] = src[0];
            dst++;
            src++;
        }
    }

    imageDebugPrint(x,y,w,h);

    // Vsync wait
    if(eConf.vsync && !skip_next_vsync) {
        pgWaitV();
    }
    // flip
    pgScreenFlip();
}

//
//
//
void PutImage(int x,int y,int w,int h)
{
    if(eConf.video==0 || !pgPSP()) {
      PutImageNormal(x,y,w,h);
    } else {
        PutImageGpu(x,y,w,h);
    }
}




#else // PALWORD ---------------------------------------------------------------

byte xbuf[WIDTH*HEIGHT+8];
static DWORD d_palette[65536];   // palette table

#define  PALETTE(i) ((((((i)>>2)&7)*36)/8)| (((((i)>>5)*36)/8)<<5) | (((((i)&3)*84)/8)<<10))


// initialize
void InitImage(void)
{   // create palette buffer
    int i;
    for(i=0;i<sizeof(d_palette)/sizeof(d_palette[0]);i++) {
        d_palette[i] = PALETTE((0x00ff&i)) | (PALETTE((0xff00&i)>>8)<<16);
    }
    // clear image buffer
    ClearImage();
    XBuf = xbuf;
}


//--------------------------------------------------------------------------
// t[`揈
//--------------------------------------------------------------------------
void PutImage(int x,int y,int w,int h)
{
    register int sx = (SCREEN_WIDTH - w)/2;
    register int sy = (SCREEN_HEIGHT- h)/2;
    register int j;
    for(j=0;j<h;j++) {  
        register DWORD* dst = (DWORD*)pgGetVramAddr(sx,sy+j);
        register WORD * src = (WORD*)&XBuf[(WIDTH*j)+x];
        register DWORD* end = dst + w/2;
        for(;dst!=end;){
            *dst++ = d_palette[*src++];
        }
    }
    
    // t[̏vtick߂
    {
        register DWORD curtick = sceKernelLibcClock();
        framerate = (framerate + (curtick-lasttick))/2;
        lasttick = curtick;
    }
    
    if(eConf.debug) {
        mh_print_dec(0,0,1000000/framerate,RGB_WHITE);
        mh_print_hex4(0,10,x,RGB_WHITE);
        mh_print_hex4(0,20,y,RGB_WHITE);
        mh_print_hex4(0,30,w,RGB_WHITE);
        mh_print_hex4(0,40,h,RGB_WHITE);
#ifdef SOUND
        dbgSound();
#endif // SOUND
#ifdef CDEMULATION
        dbgCDPlay();
#endif//CDEMULATION
    }

    // page flip
    if(eConf.vsync) pgWaitV();
    pgScreenFlip();
}

#endif// PALWORD ---------------------------------------------------------------





// image clear
void ClearImage(void)
{
    //_memset(xbuf[0],0,WIDTH*HEIGHT*sizeof(PALFMT));
    //_memset(xbuf[1],0,WIDTH*HEIGHT*sizeof(PALFMT));
}

